/**************************************************************************/
/*                                                                        */
/* Base for creating games v1.0                           (c) r00t 2003   */
/*                                                                        */
/**************************************************************************/
/*                                                                        */
/* Functions included:  Widget events handlers, timers, gfx funcs, random */
/*                                                                        */
/*                                                                        */
/* Ported to J7/70 3.10/4 by NiMar                                        */
/* You'll need up to date J70_NM_Lib.h to compile this file               */
/* Download it from http://sony.nm.ru                                     */
/**************************************************************************/

.text
.code 16
.globl _start

.align 4
program_start:
@.word 0x20031004      @ version 3.10/4 OOK2 series PRGLoader 2.0
.word 0x20000000      @ version UFIF
.string "EggHunt 0b1"  @ Program Name 15 chars max

.org 0x14
_start:
  b    .Main

.equ J7_3.10_4,0

.xdef DISPLAY            @ memory management functions
.xdef MEMORY             @ memory management functions
.xdef STRINGS            @ strings functions          
.xdef NVM               @ NVM functions              
.xdef WINDOWS            @ windows functions          
@.xdef MENU_EV           @ Menu Events functions      
@.xdef MONITOR           @ Monitor Mode function      
.xdef TIMER              @ Timer function      
@.xdef NIMAR_DELAY       @ Delay :) functions
@.xdef DIRECT_KEYBOARD   @ Keyboard functions
@.xdef DEBUG              @ Debug functions            
.xdef RANDOM
.xdef GFX
.xdef UFIF

@.include "..\\J70_NM_Lib.h"
.include "..\\Jxx_NM_Lib_OOK2_UFIF.h"
.include "denver.h"

.align 2
/********* FW functions *********/

/****************************/
/*********[ Events ]*********/
/****************************/

.align 1
.CallOldEvent:
  push {r5}
  ldr  r5,OldEvents
  lsl  r4,r4,#3
  add  r4,r4,#12
  ldr  r4,[r5,r4]
  pop  {r5}
  bx   r4

.SetNewEvent:
  ldr  r2,NewEvents
  lsl  r0,r0,#3
  add  r0,r0,#12
  str  r1,[r2,r0]
  mov  pc,lr

.HookEvents:
  push {r4-r5,lr}
  mov  r4,r0

  mov  r0,#0xA4  /* 2*41*8 = 0x290 */
  lsl  r0,r0,#2

  mov  r1,#8
  add  r0,r0,r1

  bl   .malloc
  adr  r1,OldEvents
  str  r0,[r1]

  ldr  r1,[r4,#0x10]
  mov  r2,#0xFF
  add  r2,r2,#0x49
  bl   .memcpy

  mov  r1,r0
  mov  r2,#0xFF
  add  r2,r2,#0x49
  add  r0,r0,r2
  adr  r5,NewEvents
  str  r0,[r5]
  mov  r5,r0
  bl   .memcpy
                           /* Here you can set any event handler */
  mov  r0,#0x15
  adr  r1,.NewEvent_Key
  add  r1,r1,#1
  bl   .SetNewEvent

  mov  r0,#0x1A
  adr  r1,.NewEvent_Destroy
  add  r1,r1,#1
  bl   .SetNewEvent

  mov  r0,#0x13
  adr  r1,.NewEvent_Paint
  add  r1,r1,#1
  bl   .SetNewEvent

  mov  r0,#0x29
  adr  r1,.MyTimerFunc
  add  r1,r1,#1
  bl   .SetNewEvent

  str  r5,[r4,#0x10]
  pop  {r4-r5,pc}


.UnhookEvents:
  push {lr}
  ldr  r0,OldEvents
  bl   .free
  pop  {pc}


.align 2
OldEvents: .word 0
NewEvents: .word 0

/********* Main *********/

.Main:
  push {r4-r7,lr}
  mov     r6,r0

 @ You can place some initialization code here,
 @ but you can use OnCreate event too

	bl .Init

  bl      .GetWindowManager
  mov     r5,r0

  mov     r0,#0x70
  bl      .malloc
  mov     r4,r0

  mov     r0,r6
  cmp     r0,#0
  bne     .skip_wnd
  mov     r0,#0x7D
  lsl     r0,r0,#4
  bl      .GetWindowById
.skip_wnd:

  mov     r2,r5
  mov     r1,r0
  mov     r0,r4
  bl      .cWindowWidget_Create

  mov     r0,r4
  bl      .HookEvents


  adr     r0,TimerFuncs
  str     r0,[r4,#0x4C]

  adr     r1,.MyTimerFunc
  add     r1,#1
  str     r1,[r0,#0xC]
  adr     r1,.NewEvent_Destroy
  add     r1,#1
  str     r1,[r0,#0x14]

  mov     r0,#0x50
  add     r0,r4,r0
  mov     r1,#0x4C
  add     r1,r4,r1
  bl      .Time_CreateServer

  mov     r0,#0x50
  add     r0,r4,r0
  ldr     r1,Interval
  mov     r2,#1
  bl      .Time_SetInterval   /* Init timer */

  mov     r0,r4
  pop     {r4-r7,pc}

/****************************************/
/*********[ New event handlers ]*********/
/****************************************/

.align 2
.NewEvent_Key:                @@@@@@@@ OnKeyPressed @@@@@@@@
  push {r4,lr}
  push {r0-r3}
  ldrh r2,[r1,#0xE]
  ldrh r1,[r1,#0xC]

  @ Your keyhandler code here
  @  r2 - Key scancode
  @       0x30 .. 0x39 - "0".."9"
  @       0x23 - "#"
  @       0x2a - "*"
  @  r1 - Event type (101h,106h,107h,...)
  @          0x106 - key pressed
  @          0x107 - key unpressed
  @        0x101 & scan 0x09 - RedButton pressed
  @        0x101 & scan 0x56 - CenterKey pressed
  @        0x101 & scan 0x08 - CenterKey holded
  @        0x101 & scan 0x07 - CenterKey unpressed
  @        0x101 & scan 0x0b - GreenButton pressed
  @        0x101 & scan 0x03 - JogUp
  @        0x101 & scan 0x05 - JogDown
  @        0x101 & scan 0x56 - JogPress
  @        0x101 & scan 0x4d - JogRelase
  @        0x101 & scan 0x0c - JogHold
  bl .Keys
  .ifdef DEBUG
        adr     r0, debug_keypressed
        bl      .printf
  .endif

  pop  {r0-r3}               /* In every handler you NEED to pass   */
  mov  r4,#0x15              /* old registers r0-r3 to CallOldEvent */
  bl   .CallOldEvent
  pop  {r4,pc}

.align 2
debug_keypressed: .string "type:%x; scancode:%x\n"

.align 2
.NewEvent_Destroy:            @@@@@@@@ OnDestroy @@@@@@@@
  push {r4,lr}
  push {r0-r3}

  mov  r1,#0x50
  add  r0,r0,r1
  mov  r1,#2                 /* Destroy timer */
  bl   .Time_DestroyServer

  @ Place your deinitialization here
  bl .Exit
  @  (some free(), etc)

  pop  {r0-r3}
  mov  r4,#0x1A
  bl   .CallOldEvent
  bl   .UnhookEvents
  pop  {r4,pc}


.align 2
.NewEvent_Paint:
  push {r4-r5,lr}
  mov  r5,r0
  mov  r4,#0x13
  bl   .CallOldEvent       /* for widget this clear screen to color 3 */

  @ Insert any code here
bl .Draw


  pop  {r4-r5,pc}          @@ After return, screen is repainted, you don't
                           @@ need to call Repaint in this Paint_event

.align 2
.MyTimerFunc:                 @@@@@@@@ OnTimer @@@@@@@@
  push {r4-r6,lr}
  mov  r4,r0

  @ Your timer handler code here
  bl .Step

  mov  r0,r4             @@ This will repaint the window using Paint event
  bl   .WindowRepaint    @@ Use this metod for drawing, don't draw in timer

  mov  r0,#0x50
  add  r0,r4,r0
  bl   .Time_Repeat        /* Refresh timer - only one parameter r4+0x50 */

  pop  {r4-r6,pc}

/**********************************************************************/

.align 2
Interval:    .word 30    /* Not in ms - smaller -> shorter time */
TimerFuncs:  .word 0x4C  /* Functions base for timer event structure */
             .word 0
             .word 0xFFB4
             .word 0x0
             .word 0xFFB4
             .word 0x0
.align 2
.Draw:
push {r0-r3,lr}
bl .ViewBackground
bl .DrawPlayer
bl .DrawEgges
bl .draw_score
bl .draw_face
bl .draw_window
bl .draw_sound
bl .draw_pause
bl .draw_gover
bl .draw_des
pop  {r0-r3,pc}

.align 2
.Step:
push {r0-r3,lr}
bl .CheckStop
cmp r0,#1
beq Step_skip

bl .CheckPause
cmp r0,#1
beq Step_skip

bl .speed_work
bl .incubation_work
bl .work_window
bl .work_face
Step_skip:
pop  {r0-r3,pc}

.align 2
.Init:
push {r0-r3,lr}
bl .InitRandom
bl .SetStop
bl .next_game
bl	.GameSectionGet
pop  {r0-r3,pc}


@@@@@@@@@@@@@@@@@@@@ next_game @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.next_game:
push {r0-r2,lr}
	bl .init_score
	bl .Init_window	
	bl .clear_game_over
	bl .Init_eggs
	bl .clear_de
	bl .clear_incubation
pop  {r0-r2,pc}


.include "keys.h"
.include "background.h"
.include "player.h"
.include "algo.h"
.include "timer.h"
.include "other.h"
.include "save.h"

program_end:


